#include "DinamickoPolje2.h"

int	Inicijaliziraj(struct DinamickoPolje *Polje, int MaxBrojElem)
{
	Polje->Podaci = (int *) malloc(MaxBrojElem * sizeof(int));
	Polje->BrojElem = 0;
	Polje->MaxBrojElemenata = MaxBrojElem;

	if( Polje->Podaci == NULL )
		return 1;
	else
		return 0;
}
void Izbrisi(struct DinamickoPolje *Polje)
{
	free(Polje->Podaci);
}

int PostaviNovuVelicinu(struct DinamickoPolje *Polje, int NoviBrojElem)

{
	Polje->Podaci = (int *) realloc(Polje->Podaci, NoviBrojElem * sizeof(int));
/*
Napomena:
 Drugi argument predstavlja traenu novu veliinu bloka u bajtovima
 Sadraj bloka je nepromijenjen, gledano do manje od dvije veliine --
 nove i stare veliine bloka - iako novi blok moe biti na drugoj lokaciji
 Uoite da se nigdje ne spominje eksplicitno da e se stari sadraj
 KOPIRATI, ve samo pie da e sadraj nakon realokacije biti isti
*/
	
	if( Polje->BrojElem > NoviBrojElem)			// znai da SMANJUJEMO polje
		Polje->BrojElem = NoviBrojElem;

	Polje->MaxBrojElemenata = NoviBrojElem;

	if( Polje->Podaci == NULL )
		return 1;
	else
		return 0;
}

void	PostaviElement(struct DinamickoPolje *Polje, int Indeks, int Vrijednost)
{
	if( 0 <= Indeks && Indeks < Polje->MaxBrojElemenata )
	{
		Polje->Podaci[Indeks] = Vrijednost;
		if( Indeks >= Polje->BrojElem )			
		{
			/* znai da smo stavili novi element 
			   izvan dosadanje "granice" polja
			   ali unutar raspoloivog (alociranog) prosotra */
			Polje->BrojElem = Indeks + 1;

			/* dodatni problem : 
			   vrijednosti elemenata polja 
			   izmeu prijanje granice 
			   i novododanog elementa su NEDEFINIRANE!
		    */
		}
	}
	else
	{

		// A TO SAD !!!!!????? - Problem 1
	}
}
int		DohvatiElement(struct DinamickoPolje *Polje, int Indeks)
{
	if( 0 <= Indeks && Indeks < Polje->MaxBrojElemenata )
		return Polje->Podaci[Indeks];
	else
	{
		// A TO SAD !!!!!?????
		return 0;				// neto MORAMO vratiti (zbog prototipa funkcije !)
	}
}
int		DodajElementNaKraj(struct DinamickoPolje *Polje, int Vrijednost)
{
	int		ret = 0;
	// treba provjeriti ima li mjesta za novi element
	if( Polje->BrojElem == Polje->MaxBrojElemenata )
	{
		// znai da moramo alocirati dodatni prostor
		ret = PostaviNovuVelicinu(Polje, Polje->BrojElem + 1);
		
		if( ret != 0 )			// ako nismo uspjeli povecati polje
			return ret;
	}

	Polje->Podaci[Polje->BrojElem++] = Vrijednost;

	// ili alternativno:
	//	PostaviElement(Polje, Polje->BrojElem, Vrijednost);

	return 0;
}

int		BrojElemenata(struct DinamickoPolje *Polje)
{
	return Polje->BrojElem;
}

